/*******************************************************************
	PKLib	2.0

	The final multicomponent library

	(c) Copyright 19911995 Marco Savegnago IW3FQG 	- All rights reserved

	This software can be freely copied for non-commercial use.

	DOS Multitasking Accesories

	Autore				Data        Note
	------				----		----

	Marco Savegnago     21/11/93    Scritto e collaudato il modulo

*******************************************************************/

// PKLib include

#include <task/taskutil.h>

// CRTL Include

#include <new.h>
#include <alloc.h>

resourceptr TDOSIntResource::interrupt_resource=(resourceptr(0L));

TDOSIntResource::TDOSIntResource()
{
	if(interrupt_resource==(resourceptr(0L)))
		TDOSIntResource::interrupt_resource=::create_resource (LNULL TN((byte *)"INTRPRSC"));
}

TDOSIntResource::~TDOSIntResource()
{
	::delete_resource(interrupt_resource);
}

int TDOSIntResource::int86( int __intno, union REGS *__inregs, union REGS *__outregs )
{

#ifdef	USE_CRITICAL_SECTION
	CRITICAL;
#endif	// USE_CRITICAL_SECTION

	if (ctask_active)
		::request_resource (interrupt_resource, 0L);
#ifdef	USE_CRITICAL_SECTION
	C_ENTER;
#endif	// USE_CRITICAL_SECTION

	int ret=::int86(__intno, __inregs, __outregs);

#ifdef	USE_CRITICAL_SECTION
	C_LEAVE;
#endif	// USE_CRITICAL_SECTION

	if (ctask_active)
		::release_resource (interrupt_resource);

	return ret;
}

int TDOSIntResource::int86x( int __intno, union REGS *__inregs, union REGS *__outregs, struct SREGS *__segregs )
{

#ifdef	USE_CRITICAL_SECTION
	CRITICAL;
#endif	// USE_CRITICAL_SECTION

	if (ctask_active)
		::request_resource (interrupt_resource, 0L);

#ifdef	USE_CRITICAL_SECTION
	C_ENTER;
#endif	// USE_CRITICAL_SECTION

	int ret=::int86x(__intno, __inregs, __outregs, __segregs);

#ifdef	USE_CRITICAL_SECTION
	C_LEAVE;
#endif	// USE_CRITICAL_SECTION

	if (ctask_active)
		::release_resource (interrupt_resource);

	return ret;
}

/*
int TDOSIntResource::int86( int __intno, union REGS *__inregs, union REGS *__outregs )
{
	Lock(this);

	return ::int86(__intno, __inregs, __outregs);
}

int TDOSIntResource::int86x( int __intno, union REGS *__inregs, union REGS *__outregs, struct SREGS *__segregs )
{
	Lock(this);

	return ::int86x(__intno, __inregs, __outregs, __segregs);
}
*/

/*******************************************************************
	New and delete replacement using resource
*******************************************************************/

/*******************************************************************

	alloc_resource e' al risorsa globale inizializzata dal multitasker
	durante l'inizializzazione

*******************************************************************/


void *operator new( size_t size )
{
	void * p;

	if (ctask_active)
		::request_resource (&alloc_resource, 0L);

	size = size ? size : 1;

	while ( (p = malloc(size)) == NULL && _new_handler != NULL)
		_new_handler();

	if (ctask_active)
		::release_resource (&alloc_resource);

	return p;
}

void far * operator new( unsigned long size )
{
	void far * p;

	if (ctask_active)
		::request_resource (&alloc_resource, 0L);

	size = size ? size : 1;
	while ( (p = farmalloc(size)) == NULL && _new_handler != NULL)
		_new_handler();

	if (ctask_active)
		::release_resource (&alloc_resource);

	return p;
}


void operator delete( void _FAR *ptr )
{
	if (ctask_active)
		::request_resource (&alloc_resource, 0L);

	free(ptr);

	if (ctask_active)
		::release_resource (&alloc_resource);
}

#if defined(__TINY__) || defined(__SMALL__) || defined(__MEDIUM__)
void operator delete( void far *ptr )
{

	if (ctask_active)
		::request_resource (&alloc_resource, 0L);

	if (FP_SEG(ptr) == _DS)
		free((void *) ptr);
	else
		farfree(ptr);

	if (ctask_active)
		::release_resource (&alloc_resource);

}
#endif
